/**
 * Erlaubt das Belegen eines Objekts durch einen Thread.
 * Es kann zu jeder Zeit nur ein Thread das Objekt belegen.
 */
public interface Blocking
{
    /**
     * Liefert den Thread, der gerade das Objekt belegt hat, oder null.
     * Achtung, dies sollte nur zu Diagnosezwecken verwendet werden!
     * @return den belegenden Thread oder null
     */
    public Thread blocking();

    /**
     * Belegt das Objekt.
     * Ist das Objekt bereits belegt, kehrt diese Methode erst zurck,
     * wenn es wieder freigegeben wird.
     * @exception InterruptedException  ein wartender Thread wurde unterbrochen
     */
    public void block() throws InterruptedException;

    /**
     * Gibt das Objekt wieder frei.
     * Warten andere Threads auf die Freigabe, so wird nichtdeterministisch
     * einer davon ausgewhlt und belegt als nchster das Objekt.
     */
    public void unblock();
}
