public class Node {
	private Block block = new Block();
	private int nr;
	public Node[] links = new Node[8]; 
	public boolean isStartPoint = false;
	public boolean isEndPoint = false;

	public Node(int nr) {
		// initialisere Knoten mit Richtungen
		this.nr = nr;
		for (int i=0; i<=7; i++) {
			links[i] = null;
		}
	}
	
	public void setLink(Node neighbour, int direction) {
		if (direction<0 || direction>7) {
			System.out.println("falsche Richtung: "+direction);
		} else {
			links[direction] = neighbour;
		}
	}

	public void setStartPoint() {
		if (isEndPoint) {
			System.out.println("Knoten ist schon Zielpunkt!");
		} else {
			isStartPoint = true;
		}
	}

	public void setEndPoint() {
		if (isStartPoint) {
			System.out.println("Knoten ist schon Startpunkt!");
		} else {
			isEndPoint = true;
		}
	}

	public Node getLink(int direction) {
		return links[direction];
	}

	/** 
	 * get all directions you can reach from this node
	 * @return int[]
	 */
	public int[] getLinks() {
		int linkCount = 0;
		for (int i=0; i<=7; i++) {
			if (links[i] != null) {
				linkCount++;
			}
		}
		int[] result = new int[linkCount];
		int j = 0;
		for (int i=0; i<=7; i++) {
			if (links[i] != null) {
				result[j] = i;
				j++;
			}
		}
		return result;
	}
	
	public int getNodeNumber(){
		return nr;
	}
	
	public void block() {
		try {
			block.block();
		} catch (InterruptedException e) {
			System.out.println("block was interrupted");
		}
	}

	public void unblock() {
		block.unblock();
	}
}
