import java.util.Random;

public class Lorry extends Thread {
	private Route route;
	private Node currentNode;
	private int currentDirection; 
	private int nr;
	
	public Lorry(Route route, int nr) {
		this.route = route;
		this.nr = nr;
	}

	public void run() {
		currentNode = chooseStartPoint();
		System.out.println("LKW "+nr+" startet von Knoten "+currentNode.getNodeNumber());
		currentNode.block();
		System.out.println("LKW "+nr+" hat blockiert "+currentNode.getNodeNumber());
		while (!currentNode.isEndPoint) {
			if (existsWayStraightForward()) {
				// Weg geradeaus existiert
				chooseDirection(currentDirection);
			} else {
				// finde anderen Weg
				// whle zufllig Weg aus 
				Random r = new Random();
				int i = r.nextInt(2);
				int rightDirection = (currentDirection+1) % 8;
				int leftDirection = (currentDirection+1) % 8;
				if (i==0) {
					if (existsWay(rightDirection)) {
						chooseDirection(rightDirection);
					} else if (existsWay(leftDirection)) {
						chooseDirection(leftDirection);
					} else {
						System.out.println("LKW "+nr+" : Irgendwie finde ich keinen Weg");
					}
				} else {
					if (existsWay(leftDirection)) {
						chooseDirection(leftDirection);
					} else if (existsWay(rightDirection)) {
						chooseDirection(rightDirection);
					} else {
						System.out.println("LKW "+nr+" : Irgendwie finde ich keinen Weg");
					}
				}
			}
		}
		System.out.println("LKW "+nr+" hat Zielknoten "+currentNode.getNodeNumber()+" erreicht");
	}

	public void chooseDirection(int direction) {
		currentDirection = direction;
		Node oldNode = currentNode; 
		currentNode = getNextNode(currentDirection);
		System.out.println("LKW "+nr+" versucht Knoten "+currentNode.getNodeNumber() + " zu blockieren");
		currentNode.block();
		System.out.println("LKW "+nr+" auf Knoten "+currentNode.getNodeNumber());
		oldNode.unblock();
		System.out.println("LKW "+nr+" lsst "+oldNode.getNodeNumber() + " frei.");
	}
	
	private Node chooseStartPoint() {
		Node result = route.getRandomStartPoint();
		currentDirection = result.getLinks()[0];
		return result;
	}
	
	private boolean existsWayStraightForward() {
		return existsWay(currentDirection);
	}
	
	private boolean existsWay(int direction) {
		boolean result = false;
		int[] directions = currentNode.getLinks();
		for (int i=0; i<directions.length; i++) {
			if (direction == directions[i]) {
				result = true;
			}
		}
		return result;
	}

	private Node getNextNode(int direction) {
		return currentNode.getLink(direction);
	}
}
